"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactNative = require("react-native");

var _BouncyCheckbox = _interopRequireWildcard(require("./BouncyCheckbox.style"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const defaultCheckImage = require("./check.png");

class BouncyCheckbox extends React.Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "onPress", () => {
      const {
        disableBuiltInState = false,
        useNativeDriver = true,
        bounceEffect = 1,
        bounceFriction = 3
      } = this.props;
      const {
        checked,
        springValue
      } = this.state;

      if (!disableBuiltInState) {
        this.setState({
          checked: !checked
        }, () => {
          springValue.setValue(0.7);

          _reactNative.Animated.spring(springValue, {
            toValue: bounceEffect,
            friction: bounceFriction,
            useNativeDriver
          }).start();

          this.props.onPress && this.props.onPress(this.state.checked);
        });
      } else {
        springValue.setValue(0.7);

        _reactNative.Animated.spring(springValue, {
          toValue: bounceEffect,
          friction: bounceFriction,
          useNativeDriver
        }).start();

        this.props.onPress && this.props.onPress(this.state.checked);
      }
    });

    _defineProperty(this, "renderCheckIcon", () => {
      const {
        checked,
        springValue
      } = this.state;
      const {
        size = 25,
        iconStyle,
        iconComponent,
        iconImageStyle,
        fillColor = "#ffc484",
        ImageComponent = _reactNative.Image,
        unfillColor = "transparent",
        disableBuiltInState,
        isChecked,
        checkIconImageSource = defaultCheckImage
      } = this.props;
      const checkStatus = disableBuiltInState ? isChecked : checked;
      return /*#__PURE__*/React.createElement(_reactNative.Animated.View, {
        style: [{
          transform: [{
            scale: springValue
          }]
        }, (0, _BouncyCheckbox._iconContainer)(size, checkStatus, fillColor, unfillColor), iconStyle]
      }, iconComponent || checkStatus && /*#__PURE__*/React.createElement(ImageComponent, {
        source: checkIconImageSource,
        style: [_BouncyCheckbox.default.iconImageStyle, iconImageStyle]
      }));
    });

    _defineProperty(this, "renderCheckboxText", () => {
      const {
        text,
        textComponent,
        isChecked,
        textStyle,
        textContainerStyle,
        disableBuiltInState,
        disableText = false
      } = this.props;
      const {
        checked
      } = this.state;
      return !disableText && (textComponent || /*#__PURE__*/React.createElement(_reactNative.View, {
        style: [_BouncyCheckbox.default.textContainer, textContainerStyle]
      }, /*#__PURE__*/React.createElement(_reactNative.Text, {
        style: [(0, _BouncyCheckbox._textStyle)(disableBuiltInState ? isChecked : checked), textStyle]
      }, text)));
    });

    this.state = {
      checked: false,
      springValue: new _reactNative.Animated.Value(1)
    };
  }

  componentDidMount() {
    this.setState({
      checked: this.props.isChecked || false
    });
  }

  render() {
    const {
      style,
      TouchableComponent = _reactNative.TouchableOpacity
    } = this.props;
    return /*#__PURE__*/React.createElement(TouchableComponent, _extends({}, this.props, {
      style: [_BouncyCheckbox.default.container, style],
      onPress: this.onPress.bind(this, _reactNative.Easing.bounce)
    }), this.renderCheckIcon(), this.renderCheckboxText());
  }

}

var _default = BouncyCheckbox;
exports.default = _default;
//# sourceMappingURL=BouncyCheckbox.js.map