"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports._textStyle = exports._iconContainer = void 0;

var _reactNative = require("react-native");

const _iconContainer = (size, checked, fillColor, unfillColor) => {
  return {
    width: size,
    height: size,
    borderWidth: 1,
    borderColor: fillColor,
    borderRadius: size / 2,
    alignItems: "center",
    justifyContent: "center",
    backgroundColor: checked ? fillColor : unfillColor
  };
};

exports._iconContainer = _iconContainer;

const _textStyle = checked => {
  return {
    fontSize: 16,
    color: "#757575",
    textDecorationLine: checked ? "line-through" : "none"
  };
};

exports._textStyle = _textStyle;

var _default = _reactNative.StyleSheet.create({
  container: {
    alignItems: "center",
    flexDirection: "row"
  },
  iconImageStyle: {
    width: 10,
    height: 10
  },
  textContainer: {
    marginLeft: 16
  }
});

exports.default = _default;
//# sourceMappingURL=BouncyCheckbox.style.js.map