function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import * as React from "react";
import { Text, View, Image, Easing, Animated, TouchableOpacity } from "react-native";
import styles, { _textStyle, _iconContainer } from "./BouncyCheckbox.style";

const defaultCheckImage = require("./check.png");

class BouncyCheckbox extends React.Component {
  constructor(props) {
    super(props);

    _defineProperty(this, "onPress", () => {
      const {
        disableBuiltInState = false,
        useNativeDriver = true,
        bounceEffect = 1,
        bounceFriction = 3
      } = this.props;
      const {
        checked,
        springValue
      } = this.state;

      if (!disableBuiltInState) {
        this.setState({
          checked: !checked
        }, () => {
          springValue.setValue(0.7);
          Animated.spring(springValue, {
            toValue: bounceEffect,
            friction: bounceFriction,
            useNativeDriver
          }).start();
          this.props.onPress && this.props.onPress(this.state.checked);
        });
      } else {
        springValue.setValue(0.7);
        Animated.spring(springValue, {
          toValue: bounceEffect,
          friction: bounceFriction,
          useNativeDriver
        }).start();
        this.props.onPress && this.props.onPress(this.state.checked);
      }
    });

    _defineProperty(this, "renderCheckIcon", () => {
      const {
        checked,
        springValue
      } = this.state;
      const {
        size = 25,
        iconStyle,
        iconComponent,
        iconImageStyle,
        fillColor = "#ffc484",
        ImageComponent = Image,
        unfillColor = "transparent",
        disableBuiltInState,
        isChecked,
        checkIconImageSource = defaultCheckImage
      } = this.props;
      const checkStatus = disableBuiltInState ? isChecked : checked;
      return /*#__PURE__*/React.createElement(Animated.View, {
        style: [{
          transform: [{
            scale: springValue
          }]
        }, _iconContainer(size, checkStatus, fillColor, unfillColor), iconStyle]
      }, iconComponent || checkStatus && /*#__PURE__*/React.createElement(ImageComponent, {
        source: checkIconImageSource,
        style: [styles.iconImageStyle, iconImageStyle]
      }));
    });

    _defineProperty(this, "renderCheckboxText", () => {
      const {
        text,
        textComponent,
        isChecked,
        textStyle,
        textContainerStyle,
        disableBuiltInState,
        disableText = false
      } = this.props;
      const {
        checked
      } = this.state;
      return !disableText && (textComponent || /*#__PURE__*/React.createElement(View, {
        style: [styles.textContainer, textContainerStyle]
      }, /*#__PURE__*/React.createElement(Text, {
        style: [_textStyle(disableBuiltInState ? isChecked : checked), textStyle]
      }, text)));
    });

    this.state = {
      checked: false,
      springValue: new Animated.Value(1)
    };
  }

  componentDidMount() {
    this.setState({
      checked: this.props.isChecked || false
    });
  }

  render() {
    const {
      style,
      TouchableComponent = TouchableOpacity
    } = this.props;
    return /*#__PURE__*/React.createElement(TouchableComponent, _extends({}, this.props, {
      style: [styles.container, style],
      onPress: this.onPress.bind(this, Easing.bounce)
    }), this.renderCheckIcon(), this.renderCheckboxText());
  }

}

export default BouncyCheckbox;
//# sourceMappingURL=BouncyCheckbox.js.map